import gtk
import os.path
import sys


class BzrDialog(gtk.Dialog):
    def __init__(self):
        pass
    
    def disable_widgets(self):
        def _disable(item):
            item.set_sensitive(False)
        self.action_area.foreach(_disable)


    def set_status(self,text):
        self._status.set_markup("<i>%s</i>" % text)
        while gtk.events_pending():
            gtk.main_iteration()
            
class BzrInputDialog(BzrDialog):
    _response = None
    _entry = None
    
    def __init__(self,defaultvalue = "",bigtext = "", text = "",title = "",):
        gtk.Dialog.__init__(self,title,None)
        entry = gtk.Entry()
        hbox = gtk.HBox()
        self.vbox.pack_start(hbox)
        self.vbox.set_spacing(2)
        img = gtk.Image()
        img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(img)
        hbox.set_spacing(10)
        vbox = gtk.VBox()
        vbox.set_spacing(10)
        hbox.pack_start(vbox)

        lbltit = gtk.Label("<big><b>%s</b></big>" % bigtext)#"<big><b>Select path to INIT</b></big>")
        lbltit.set_padding(0,10)
        lbltit.set_use_markup(True)
        lbltit.set_alignment(0,0)
        vbox.pack_start(lbltit)
        lbl = gtk.Label(text)#"Choose which is the path where you want to create this bzr")
        lbl.set_alignment(0,0)
        vbox.pack_start(lbl)
        entry = gtk.Entry()
        entry.set_text(defaultvalue)
        buthbox = gtk.HBox()
        self.entrybox = buthbox
        buthbox.pack_start(entry)
        vbox.pack_start(buthbox)
        self._statusbox = gtk.VBox()
        self._status = gtk.Label()
        self._statusbox.pack_start(self._status)
        self._status.set_use_markup(True)
        vbox.pack_start(self._statusbox)
        self._status.set_alignment(0,0)
        self.vbox.show_all()
        self.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_OK)
        self._entry = entry

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode =  gtk.Dialog.run(self)
        return (returncode,self._entry.get_text())

    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._entry.set_sensitive(False)
        
class BzrInputFileDialog(BzrInputDialog):
    _response = None
    _entry = None
    
    def __init__(self,defaultvalue = "",bigtext = "", text = "",title = "",):
        BzrInputDialog.__init__(self,defaultvalue,bigtext,text,title)
        butbrowse = gtk.Button(_("Open"),gtk.STOCK_OPEN)
        butbrowse.connect("clicked",self._clicked)
        butbrowse.show()
        self.entrybox.pack_start(butbrowse)
    
    def _clicked(self,but):
        dlg = gtk.FileChooserDialog("Choose patch",buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL, gtk.STOCK_OK,gtk.RESPONSE_OK))
        ret = dlg.run()
        if ret == gtk.RESPONSE_OK:
            file = dlg.get_filename()
            if file != None and file != '':
                self._entry.set_text(file)
        dlg.destroy()

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode =  gtk.Dialog.run(self)
        return (returncode,self._entry.get_text())

    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._entry.set_sensitive(False)
        
        

        
class BzrDobleInputDialog(BzrDialog):
    _return = None
    _response = None
    _entry = None

    def __init__(self,defaultvalue1 = "",
                             defaultvalue2 = "",bigtext = "", text = "",text2 = "",title = "",):
        gtk.Dialog.__init__(self,title,None)

        entry = gtk.Entry()
        hbox = gtk.HBox()
        self.vbox.pack_start(hbox)
        self.vbox.set_spacing(2)
        img = gtk.Image()
        img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(img)
        hbox.set_spacing(10)
        vbox = gtk.VBox()
        vbox.set_spacing(10)
        hbox.pack_start(vbox)

        lbltit = gtk.Label("<big><b>%s</b></big>" % bigtext)#"<big><b>Select path to INIT</b></big>")
        lbltit.set_padding(0,10)
        lbltit.set_use_markup(True)
        lbltit.set_alignment(0,0)
        vbox.pack_start(lbltit)
        lbl = gtk.Label(text)#"Choose which is the path where you want to create this bzr")
        lbl.set_alignment(0,0)
        vbox.pack_start(lbl)
        entry = gtk.Entry()
        entry.set_text(defaultvalue1)
        self.entrybox1 = gtk.HBox()
        self.entrybox1.pack_start(entry)
        vbox.pack_start(self.entrybox1)

        lbl2 = gtk.Label(text2)#"Choose which is the path where you want to create this bzr")
        lbl2.set_alignment(0,0)
        vbox.pack_start(lbl2)
        entry2 = gtk.Entry()
        entry2.set_text(defaultvalue2)
        self.entrybox2 = gtk.HBox()
        self.entrybox2.pack_start(entry2)
        vbox.pack_start(self.entrybox2)
        


        self._statusbox = gtk.VBox()
        self._status = gtk.Label()
        self._status.set_use_markup(True)
        self._status.set_alignment(0,0)
        self._statusbox.pack_start(self._status)
        vbox.pack_start(self._statusbox)

        self.vbox.show_all()
        self.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_OK)
        self._entry = entry
        self._entry2 = entry2

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode = gtk.Dialog.run(self)
        ret = (returncode,self._entry.get_text(),self._entry2.get_text())
        return ret
    
    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._entry.set_sensitive(False)
        self._entry2.set_sensitive(False)

        
class BzrDobleInputFileDialog(BzrDobleInputDialog):
    _response = None
    _entry = None
    
    def __init__(self,defaultvalue1 = "",
                             defaultvalue2 = "",bigtext = "", text = "",text2 = "",title = "",):
        BzrDobleInputDialog.__init__(self,defaultvalue1,
                             defaultvalue2 ,bigtext , text ,text2 ,title)
        
        butbrowse = gtk.Button(_("Open"),gtk.STOCK_OPEN)
        butbrowse.connect("clicked",self._clicked)
        butbrowse.show()
        self.entrybox2.pack_start(butbrowse)
    
    def _clicked(self,but):
        dlg = gtk.FileChooserDialog("Choose patch",buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL, gtk.STOCK_OK,gtk.RESPONSE_OK))
        ret = dlg.run()
        if ret == gtk.RESPONSE_OK:
            file = dlg.get_filename()
            if file != None and file != '':
                self._entry2.set_text(file)
        dlg.destroy()

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode =  gtk.Dialog.run(self)
        return (returncode,self._entry.get_text(),self._entry2.get_text())

    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._entry.set_sensitive(False)
        
class BzrComitDialog(BzrDialog):
    _return = None
    _response = None
    _entry = None

    def __init__(self,path):
        gtk.Dialog.__init__(self,"Commit",None)

        hbox = gtk.HBox()
        self.vbox.pack_start(hbox)
        self.vbox.set_spacing(2)
        img = gtk.Image()
        img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(img)
        hbox.set_spacing(10)
        vbox = gtk.VBox()
        vbox.set_spacing(10)
        hbox.pack_start(vbox)

        lbltit = gtk.Label("<big><b>Commit changes in %s.</b></big>" % path)
        lbltit.set_padding(0,10)
        lbltit.set_use_markup(True)
        lbltit.set_alignment(0,0)
        vbox.pack_start(lbltit)
        lbl = gtk.Label("Please enter a comment for your commit")
        lbl.set_alignment(0,0)
        vbox.pack_start(lbl)
        scrollw = gtk.ScrolledWindow()
        textview = gtk.TextView()
        scrollw.add(textview)
        scrollw.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        frame = gtk.Frame()
        frame.add(scrollw)
        vbox.pack_start(frame)

        self._statusbox = gtk.VBox()
        self._status = gtk.Label()
        self._status.set_use_markup(True)
        self._status.set_alignment(0,0)
        self._statusbox.pack_start(self._status)
        vbox.pack_start(self._statusbox)

        self.vbox.show_all()
        self.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_REJECT,gtk.STOCK_OK,gtk.RESPONSE_OK)
        self._textview = textview

    def run(self):
        self.set_default_response(gtk.RESPONSE_OK)
        returncode = gtk.Dialog.run(self)
        buf = self._textview.get_buffer()
        bounds = buf.get_bounds()
        mytext = buf.get_text(bounds[0],bounds[1])
        ret = (returncode,mytext)
        return ret

    def disable_widgets(self):
        BzrDialog.disable_widgets(self)
        self._textview.set_sensitive(False)
        

        
def _bzrErrorDialog(title, message = None, msgtype='Error'):
    d = gtk.Dialog("Error!",None)

    hbox = gtk.HBox()
    d.vbox.pack_start(hbox)
    d.vbox.set_spacing(2)
    img = gtk.Image()
    img.set_from_stock(gtk.STOCK_DIALOG_ERROR,gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(img)
    hbox.set_spacing(10)
    vbox = gtk.VBox()
    vbox.set_spacing(10)
    hbox.pack_start(vbox)

    lbltit = gtk.Label("<b>%s:</b> %s" % (msgtype,title))
    lbltit.set_padding(0,10)
    lbltit.set_use_markup(True)
    lbltit.set_alignment(0,0)
    vbox.pack_start(lbltit)
    if message != None:
        if type(message) != str:
            message = str(message)
        scrollw = gtk.ScrolledWindow()
        textview = gtk.TextView()
        textview.get_buffer().set_text(message)
        textview.set_wrap_mode(gtk.WRAP_WORD_CHAR)

        #textview.set_size_request(-1,100)
        scrollw.add(textview)
        scrollw.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
        frame = gtk.Frame()
        frame.add(scrollw)
        vbox.pack_start(frame)
    d.vbox.show_all()
    d.add_buttons(gtk.STOCK_OK,gtk.RESPONSE_OK)
    ret = d.run()
    d.destroy()
    return True
    
    
def _bzrInfoDialog(title, message, w_h = None):
    d = gtk.Dialog(title,None)

    hbox = gtk.HBox()
    d.vbox.pack_start(hbox)
    d.vbox.set_spacing(2)
    hbox.set_spacing(10)
    vbox = gtk.VBox()
    vbox.set_spacing(10)
    hbox.pack_start(vbox)
    
    

    scrollw = gtk.ScrolledWindow()
    textview = gtk.TextView()
    textview.get_buffer().set_text(message)
    textview.set_wrap_mode(gtk.WRAP_WORD_CHAR)

    #textview.set_size_request(-1,100)
    scrollw.add(textview)
    scrollw.set_policy(gtk.POLICY_NEVER,gtk.POLICY_AUTOMATIC)
    frame = gtk.Frame()
    frame.add(scrollw)
    vbox.pack_start(frame)
    
    d.vbox.show_all()
    d.add_buttons(gtk.STOCK_OK,gtk.RESPONSE_OK)
    if w_h != None:
        d.set_default_size(w_h[0], w_h[1])
    ret = d.run()
    d.destroy()
    return True

def _bzrQuestionDialog(title, message = None,yestext = None):
    d = gtk.Dialog(title,None)

    hbox = gtk.HBox()
    d.vbox.pack_start(hbox)
    d.vbox.set_spacing(2)
    img = gtk.Image()
    img.set_from_stock(gtk.STOCK_DIALOG_QUESTION,gtk.ICON_SIZE_DIALOG)
    hbox.pack_start(img)
    hbox.set_spacing(10)
    vbox = gtk.VBox()
    vbox.set_spacing(10)
    hbox.pack_start(vbox)

    lbltit = gtk.Label("<big><b>Confirm:</b></big>")
    lbltit.set_use_markup(True)
    lbltit.set_alignment(0,0)
    lbltit.set_padding(0,10)
    vbox.pack_start(lbltit)
    lblquest = gtk.Label(message)
    lblquest.set_alignment(0,0)
    lblquest.set_use_markup(True)
    
    vbox.pack_start(lblquest)    
    d.vbox.show_all()
    if yestext == '':
        yestext = gtk.STOCK_YES
        
    d.add_buttons(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL,yestext,gtk.RESPONSE_YES)
    ret = d.run()
    d.destroy()
    return ret

def _bzrDiffDialog(title, diff):
    import pango
    import gtksourceview2 as gtksourceview
    have_gtksourceview = True

#        have_gtksourceview = False
    
    d = gtk.Dialog(title,None)

    ###
    if have_gtksourceview:
        buffer = gtksourceview.Buffer()
        slm = gtksourceview.LanguageManager()
        gsl = slm.get_language("diff")

        #self.apply_colordiff_colors(gsl)
        buffer.set_language(gsl)
        #buffer.set_highlight(True)

        sourceview = gtksourceview.View(buffer)
    else:
        buffer = gtk.TextBuffer()
        sourceview = gtk.TextView(buffer)

    sourceview.set_editable(True)
    sourceview.modify_font(pango.FontDescription("Monospace"))
    #self.add(sourceview)
    sourceview.show()
    ###
    buffer.set_text(diff)
    hbox = gtk.HBox()
    scroll = gtk.ScrolledWindow()
    scroll.add(sourceview)
    hbox.pack_start(scroll)
    
    d.vbox.pack_start(hbox)
    d.vbox.show_all()
    d.set_default_size(700, 400)
    
    d.add_buttons(gtk.STOCK_CLOSE,gtk.RESPONSE_OK)
    ret = d.run()
    d.destroy()
    return ret


class BzrNewWorkspace(gtk.Dialog):
    location = None
    isrepo = False
    currentpage = None
    createaction = 'init'
    branchname = ""
    parentlocation = ""
    
    lfpage = None 
    scapage = None
    pbpage = None
    
    
    class LocalFolderPage(gtk.VBox):
        def __init__(self, control):
            gtk.VBox.__init__(self)
            self.hbox = gtk.HBox()
            self.pack_start(self.hbox, False, False)
            
            lbl = gtk.Label("<b>Select location for new workspace:</b>")
            lbl.set_use_markup(True)
            self.hbox.pack_start(lbl,False,False)
            self.location = gtk.Entry()
            if control.location != None:
                self.location.set_text(control.location)
            self.hbox.pack_start(self.location)
            
            self.location.connect("changed",self._edited)
            
            butbrowse = gtk.Button(("Open"),gtk.STOCK_OPEN)
            butbrowse.connect("clicked",self._clicked)
            self.hbox.pack_start(butbrowse,False,False)
            self.control = control
            
           
            self.check = gtk.CheckButton("Create repository (init-repo)")
            self.pack_start(self.check,False,False)
            self.check.connect("toggled",self._toggled)
            
            self.update_ui()
            if control.isrepo != None:
                self.check.set_active(control.isrepo)
                           
        
        def update_ui(self):
            if self.control.location == None or self.control.location == '':
                self.control.set_response_sensitive(1, False)
            else:
                self.control.set_response_sensitive(1, True)
                
            self.control.set_response_sensitive(-1, False)            
            
        def _clicked(self, but):
            dlg = gtk.FileChooserDialog("Choose folder",action=gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,buttons=(gtk.STOCK_CANCEL,gtk.RESPONSE_CANCEL, gtk.STOCK_OK,gtk.RESPONSE_OK))
            ret = dlg.run()
            if ret == gtk.RESPONSE_OK:
                file = dlg.get_filename()
                if file != None and file != '':
                    self.location.set_text(file)
            dlg.destroy()

        def _toggled(self,check):
            self.control.isrepo = check.get_active()
            
        def _edited(self,entry):
            self.control.location = entry.get_text()
            self.control.set_response_sensitive(1, entry.get_text() != '')

        def title(self):
            return "Select location"

    class SelectCreateActionPage(gtk.VBox):
        def __init__(self, control):
            gtk.VBox.__init__(self)
            self.lbl = gtk.Label("<b>Selected location:</b> <i>%s</i>" % control.location)
            self.lbl.set_use_markup(True)
            self.lbl.set_alignment(0,0)
            self.pack_start(self.lbl,False,False)
            
            frame = gtk.Frame("Choose action")
            frvbox = gtk.VBox()
            frame.add(frvbox)
            self.pack_start(frame,False,False)
            
            self.but_work = gtk.RadioButton(None, "Create empty _workspace")
            self.but_work.connect("toggled",self._toggle,'init')
            
            frvbox.pack_start(self.but_work)
            
            self.but_newbra = gtk.RadioButton(self.but_work, "Create _new branch in repository")
            frvbox.pack_start(self.but_newbra)
            self.but_newbra.connect("toggled",self._toggle,'init-branch')
                
            but_bran = gtk.RadioButton(self.but_work, "_Branch from...")
            but_bran.connect("toggled",self._toggle,'branch')
            frvbox.pack_start(but_bran)            
            
            but_checo = gtk.RadioButton(self.but_work, "_Checkout from...")
            but_checo.connect("toggled",self._toggle,'checkout')
            frvbox.pack_start(but_checo)   
            
            
            lbl = gtk.Label("<b>Select branch name:</b>")
            lbl.set_use_markup(True)
            #lbl.set_alignment(-1,0)
            self.entrybranch = gtk.Entry()
            self.entrybranch.connect("changed",self._changed)
            self.branchhbox = gtk.HBox(False)
            self.branchhbox.pack_start(lbl,False,False)
            self.branchhbox.pack_start(self.entrybranch,True,True)
            self.pack_start(self.branchhbox,True,True)
                
            
            self.control = control
            self._toggle(self.but_work,'init')
            self.update_ui()
        
        def _changed(self,entry):
            if entry.get_text() == '':
                self.control.set_response_sensitive(1, False)
            else:
                self.control.set_response_sensitive(1, True)
            self.control.branchname = entry.get_text()
                
        def _toggle(self,but,type):
            if but.get_active():
                self.control.createaction = type
                if self.control.isrepo:
                    if type == 'init':
                        self.branchhbox.set_sensitive(False)
                        self.control.set_response_sensitive(1, True)
                    else:
                        self.branchhbox.set_sensitive(True)
                        self._changed(self.entrybranch)
                else:
                    self.control.set_response_sensitive(1, True)
            
        def update_ui(self):

            self.lbl.set_label("<b>Selected location:</b> <i>%s</i>" % self.control.location)
            if self.control.isrepo:
                if self.control.createaction == 'init':
                    self.control.set_response_sensitive(1, True)
                    self.branchhbox.set_sensitive(False)
                else:
                    if self.entrybranch.get_text() == '':
                        self.control.set_response_sensitive(1, False)
                    else:
                        self.control.set_response_sensitive(1, True)
                    self.branchhbox.set_sensitive(True)
                self.but_newbra.show()
                self.branchhbox.show()
            else:
                self.control.set_response_sensitive(1, True)
                self.but_newbra.hide()
                if self.but_newbra.get_active():
                    self.but_work.set_active(True)
                self.branchhbox.hide()
                
            self.control.set_response_sensitive(-1, True) 
                        
        def title(self):
            return "Select action"

    class ParentBranchPage(gtk.VBox):
        def __init__(self, control):
            gtk.VBox.__init__(self)
            hbox = gtk.HBox()
            lbl = gtk.Label("<b>Select parent branch location:</b>")
            lbl.set_use_markup(True)
            hbox.pack_start(lbl,False,False)
            
            self.locationentry = gtk.Entry()
            self.locationentry.connect("changed",self._changed)
            hbox.pack_start(self.locationentry,True,True)
            
            self.pack_start(hbox,False,True)
            
            self.control = control
        
        def _changed(self,entry):
            if entry.get_text() == '':
                self.control.set_response_sensitive(1, False)
            else:
                self.control.set_response_sensitive(1, True)
            self.control.parentlocation = entry.get_text() 
            
        def update_ui(self):
            self._changed(self.locationentry)

        
    def __init__(self, callback):
        gtk.Dialog.__init__(self,"Create workspace")

        self.callback = callback
        self.add_buttons(gtk.STOCK_GO_BACK, -1, gtk.STOCK_GO_FORWARD, 1)
       
        self.lfpage = self.LocalFolderPage(self)        
        self.vbox.add(self.lfpage)
        self.currentpage = self.lfpage
        self.connect("response",self._response)
        self.vbox.show_all()
        
        self.show_all()
                
    def _response(self, dialog, response_id):
        if response_id == 1:
            if self.currentpage == self.lfpage:
                self.vbox.remove(self.lfpage)
                if self.scapage == None:
                    self.scapage = self.SelectCreateActionPage(self)
                self.vbox.add(self.scapage)
                self.vbox.show_all()
                self.currentpage = self.scapage
                self.currentpage.update_ui()
  
            elif self.currentpage == self.scapage:
                if self.isrepo and (self.createaction == 'init' or self.createaction == 'init-branch'): #if is repo and is just creating a workspace, let's finish
                    confirmdlg = BzrNewWorkspaceConfirm(self,self.location,self.isrepo,self.createaction,
                                                        self.branchname)
                    self.hide()
                    confirmdlg.show()
                    
                else:
                    if self.createaction == 'init':
                        confirmdlg = BzrNewWorkspaceConfirm(self,self.location,self.isrepo,self.createaction,
                                                            self.branchname)
                        self.hide()
                        confirmdlg.show()
                    else:
                        self.vbox.remove(self.scapage)
                        if self.pbpage == None:
                            self.pbpage = self.ParentBranchPage(self)
                        self.vbox.add(self.pbpage)
                        self.vbox.show_all()
                        self.currentpage = self.pbpage
                        self.currentpage.update_ui()
                    
            elif self.currentpage == self.pbpage:
                confirmdlg = BzrNewWorkspaceConfirm(self,self.location,self.isrepo,self.createaction,
                                                    self.branchname,self.parentlocation)
                self.hide()
                confirmdlg.show()
                
                
        if response_id == -1:
            if self.currentpage == self.scapage:
                self.vbox.remove(self.scapage)
                self.vbox.add(self.lfpage)
                self.vbox.show_all()
                self.currentpage = self.lfpage
                self.currentpage.update_ui()
                
            elif self.currentpage == self.pbpage:
                self.vbox.remove(self.pbpage)
                self.vbox.add(self.scapage)
                self.vbox.show_all()
                self.currentpage = self.scapage
                self.currentpage.update_ui()                

class BzrNewWorkspaceConfirm(gtk.Dialog):

    def __init__(self, parent, location, isrepo, createaction, branchname, parentlocation = None):
        self.myparent = parent
        gtk.Dialog.__init__(self,"Create workspace in %s" % location)
        self.location = location
        self.isrepo = isrepo
        self.createaction = createaction
        self.branchname = branchname
        self.parentlocation = parentlocation
        
        self.add_buttons(gtk.STOCK_GO_BACK, -1, gtk.STOCK_APPLY, 1)
                
        frame = gtk.Frame("Confirm")
        self.vbox.add(frame)
        """tv = gtk.TextView()
        frame.add(tv)
        buf = tv.get_buffer()"""
        lbl = gtk.Label()
        frame.add(lbl)
        text = "<b>Create in:</b> <i>%s</i>.\n" % location
        
        if isrepo:
            text += "<b>Type</b>: "
            if createaction == 'init':
                text += "Empty repository.\n"
            elif createaction == 'init-branch':
                text += "Local repository with branch named <i>%s</i>.\n" % branchname
            elif createaction == 'branch':
                text += "Local repository with branch named <i>%s</i>\nbranched from <i>%s</i>.\n" % (branchname, parentlocation)
            elif createaction == 'checkout':
                text += "Local repository with branch named <i>%s</i>\nbound to <i>%s</i>.\n" % (branchname, parentlocation)
        else:
            text += "<b>Type:</b> "
            if createaction == 'init':
                text += "Empty local branch.\n"
            elif createaction == 'branch':
                text += "Local branch branched from\n<i>%s</i>.\n" % parentlocation
            elif createaction == 'checkout':
                text += "Local branch bound to\n<i>%s</i>.\n" % parentlocation
        lbl.set_markup(text)


        self._statusbox = gtk.VBox()
        self._status = gtk.Label()
        self.lblstatus = self._status
        self._statusbox.pack_start(self._status)
        self._status.set_use_markup(True)
        self.vbox.pack_start(self._statusbox)
        
    
        self.lblstatus.hide()
        self.vbox.show_all()
        
        
        
        
        self.connect("response",self._response)
        self.connect("destroy",lambda w: self.destroy())
           
    def set_status(self,status):
        self.lblstatus.show()
        self.lblstatus.set_markup("<i>%s</i>" % status)
        while gtk.events_pending():
            gtk.main_iteration()
        
    def _response(self, dialog, response_id):
        if response_id == -1:
            self.myparent.show()
            self.destroy()
        elif response_id == 1:
            data = [self.location,self.isrepo,self.createaction,self.branchname,self.parentlocation]
            self.set_response_sensitive(-1, False)
            self.set_response_sensitive(1, False)
            self.myparent.callback(data,self)
            self.destroy()

class BzrBranchSettings(gtk.Dialog):
    
    def __init__(self, branch):
        gtk.Dialog.__init__(self,"Branch settings")
        
        self.branch = branch
        self.add_buttons(gtk.STOCK_CANCEL, -1, gtk.STOCK_SAVE, 1)
        

        
        frame = gtk.Frame("Branch settings")
        self.vbox.add(frame)
        vbox = gtk.VBox()
        
        box = gtk.HBox()
        box.pack_start(vbox,padding=3)
        frame.add(box)
        frame.set_border_width(5)
        
        
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Branch location: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        lbl = gtk.Label(branch.bzrdir.open_workingtree().basedir)
        lbl.set_alignment(0,0)
        hbox.pack_start(lbl,True)     
        
        vbox.pack_start(hbox,False,False,padding=3)
        vbox.pack_start(gtk.HSeparator(),False,False,padding=3)
        
        
        self.conf = self.branch.get_config()
        uname = self.conf.username()
        from bzrlib import config
        uname, email = config.parse_username(uname)
                
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Your name: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entryname = gtk.Entry()
        hbox.pack_start(self.entryname,True)
        self.entryname.set_text(uname)        
        vbox.pack_start(hbox,False,False,padding=3)
        
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Your email: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entryemail = gtk.Entry()
        hbox.pack_start(self.entryemail,True)
        self.entryemail.set_text(email)        
        vbox.pack_start(hbox,False,False,padding=3)
        vbox.pack_start(gtk.HSeparator(),False,False,padding=3)
        
        
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Nick: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entrynick = gtk.Entry()
        hbox.pack_start(self.entrynick,True)
        self.entrynick.set_text(branch.nick)        
        vbox.pack_start(hbox,False,False,padding=3)


        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Parent location: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entryparentlocation = gtk.Entry()
        hbox.pack_start(self.entryparentlocation,True)
        parentlocation = branch.get_parent()
        self.entryparentlocation.set_text(parentlocation if parentlocation != None else "")
        vbox.pack_start(hbox,False,False,padding=3)


       
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Push location: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entrypushbranch = gtk.Entry()
        hbox.pack_start(self.entrypushbranch,True)
        pushbranch = branch.get_push_location()
        self.entrypushbranch.set_text(pushbranch if pushbranch != None else "")
        vbox.pack_start(hbox,False,False)
                
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Public branch location: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entrypublicbranch = gtk.Entry()
        hbox.pack_start(self.entrypublicbranch,True)
        publicbranch = branch.get_public_branch()
        self.entrypublicbranch.set_text(publicbranch if publicbranch != None else "")
        vbox.pack_start(hbox,False,False,padding=3)
        
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Submit branch location: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entrysubmitbranch = gtk.Entry()
        hbox.pack_start(self.entrysubmitbranch,True)
        submitbranch = branch.get_submit_branch()
        self.entrysubmitbranch.set_text(submitbranch if submitbranch != None else "")
        vbox.pack_start(hbox,False,False,padding=3)
        
        hbox = gtk.HBox()
        lbl = gtk.Label("<b>Bound location: </b>")
        lbl.set_use_markup(True)
        hbox.pack_start(lbl,False)
        self.entryboundlocation = gtk.Entry()
        hbox.pack_start(self.entryboundlocation,True)
        boundlocation = branch.get_bound_location()
        self.entryboundlocation.set_text(boundlocation if boundlocation != None else "")
        vbox.pack_start(hbox,False,False,padding=3)
        
        
        self.connect("response",self._response)
        self.connect("destroy",lambda x: self.destroy())
    
    def _response(self, dialog, responseid):
        if responseid == 1:
            self._save()
        else:
            self.destroy()

            
        
    def _save(self):
        if self._check():
            dodestroy = True
            # first, set name and email
            uname = self.entryname.get_text()
            email = self.entryemail.get_text()
            self.branch.get_config().set_user_option('email', "%s <%s>" % (uname,email))
            
            #set nick
            self.branch.nick = self.entrynick.get_text()
            
            #set parent location
            self.branch.set_parent(self.entryparentlocation.get_text())
            
            #set push location
            self.branch.set_push_location(self.entrypushbranch.get_text())
            
            #set public location
            self.branch.set_public_branch(self.entrypublicbranch.get_text())
            
            #set submti branch
            self.branch.set_submit_branch(self.entrysubmitbranch.get_text())
            
            # bind/unbind
            bindlocation = self.entryboundlocation.get_text()
            if bindlocation == '':
                try:
                    self.branch.unbind()
                except:
                    dodestroy = False
                    _bzrErrorDialog("Error unbinding",sys.exc_value)
            else:
                if bindlocation != self.branch.get_bound_location():
                    try:
                        bindbr= branch.Branch.open(bindlocation)
                        self.branch.bind(bindbr)
                    except:
                        dodestroy = False
                        _bzrErrorDialog("Error binding",sys.exc_value)
            if dodestroy:
                self.destroy()
    
    def _check(self):
        errors = []
        
        uname = self.entryname.get_text()
        email = self.entryemail.get_text()
        
        if uname == '' or email == '':
            errors.append("You have to enter email AND name")
        
        if self.entrynick.get_text() == '':
            errors.append("You have to enter a nick")
            
        if len(errors) > 0:
            serrors = ""
            for er in errors:
                serrors += " * %s\n" % er
                
            _bzrErrorDialog("Can't save settings",serrors)
            return False
        else:
            return True
        


        
if __name__ == '__main__':
    # this is for testing dialogs
    
    from bzrlib import branch
    
    br = branch.Branch.open("/home/javier/bzrt/repo/co")
    
    
    nw = BzrBranchSettings(br)
    nw.show_all()
    gtk.main()
    
    